package com.fr.design.event;

/**
 * Author : Shockway
 * Date: 13-7-17
 * Time: 上午10:37
 */
public interface GlobalNameObserver {

	/**
	 * 给组件登记一个全局名字观察者监听事件
	 *
	 * @param listener 观察者监听事件
	 */
	public void registerNameListener(GlobalNameListener listener);

	/**
	 * 组件是否需要响应添加的观察者事件
	 *
	 * @return 如果需要响应观察者事件则返回true，否则返回false
	 */
	public boolean shouldResponseNameListener();


	/**
	 * 设置全局名字
	 * @param name
	 */
	public void setGlobalName(String name);

}