package com.fr.design.event;


/**
 * Created by IntelliJ IDEA.
 * Author : Richer
 * Version: 7.0.3
 * Date: 13-3-18
 * Time: 下午3:00
 * 组件的事件观察者接口，用于确定UI组件是否需要响应监听事件以及增加监听事件用于监听组件是否做了改变模板值的操作
 */
public interface UIObserver {

	/**
	 * 给组件登记一个观察者监听事件
	 *
	 * @param listener 观察者监听事件
	 */
	public void registerChangeListener(final UIObserverListener listener);

	/**
	 * 组件是否需要响应添加的观察者事件
	 *
	 * @return 如果需要响应观察者事件则返回true，否则返回false
	 */
	public boolean shouldResponseChangeListener();

}